/*******************************************************************************
*                                 Sudoku                                       *
********************************************************************************
*            Copyright (C) 2006 Sander Jansen. All Rights Reserved             *
*                               ---                                            *
* This program is free software; you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation; either version 2 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
* You should have received a copy of the GNU General Public License            *
* along with this program; if not, write to the Free Software                  *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    *
*******************************************************************************/
/*
$Id$
*/
#ifndef DLX_H
#define DLX_H

struct dlxcolumn;

struct dlxnode {
  dlxnode   * left;
  dlxnode   * right;
  dlxnode   * up;
  dlxnode   * down;
  dlxcolumn * column;
  dlxnode();
  };

struct dlxcolumn : public dlxnode{
  int size;
  int name;
  dlxcolumn();
  };

class dlx {
protected:
  dlxnode   * root;
  dlxcolumn * columns;
  dlxnode   * nodes;
  int nindex;
  int found;
protected:
  dlxnode   ** solution;
protected:
  void cover(dlxcolumn *);
  void uncover(dlxcolumn *);
  void insertRow(dlxnode *);
  void removeRow(dlxnode *);
  dlxcolumn * nextColumn();
public:
  dlx(int num_columns,int num_nodes,int num_solutions);

  /// Insert Row Data
  dlxnode * initrow(int * data,int num);

  /// Find First Available Solution
  bool findFirst(int);

  /// Find All Available Solutions
  bool findAll(int);

  ~dlx();
  };
#endif


