/*******************************************************************************
*                                 Sudoku                                       *
********************************************************************************
*            Copyright (C) 2006 Sander Jansen. All Rights Reserved             *
*                               ---                                            *
* This program is free software; you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation; either version 2 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
* You should have received a copy of the GNU General Public License            *
* along with this program; if not, write to the Free Software                  *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    *
*******************************************************************************/
/*
$Id$
*/
#ifndef SUDOKU_H
#define SUDOKU_H

class Sudoku {
public:
  int num_solved;
  FXchar field[81];
public:
  /// Construct a empty Sudoku Matrix
  Sudoku();

  /// Construct sudoku matrix based s
  Sudoku(const Sudoku & s );

  /// Assign sudoku matrix
  Sudoku& operator=(const Sudoku& s);

  /// Check if two sudoku matrixes are the same
  bool operator==(const Sudoku& s) const;

  /// Check if two sudoku matrixes are notthe same
  bool operator!=(const Sudoku& s) const;

  /// Clear Sudoku Matrix
  void clear();

  /// Set Value
  void set(int r,int c,FXchar value);

  /// Get Value
  FXchar get(int r,int c) const;

  /// Set Value
  void set(int i,FXchar value);

  /// Get Value
  FXchar get(int i) const;

  /// Check if this sudoku is solved
  bool solved() const;
  
  /// Check if this sudoku is empty
  bool empty() const;

  /// Save to Stream
  void save(FXStream & store) const;

  /// Load from Stream
  void load(FXStream & store);

  /// Check if value at position would be legal.
  bool is_valid(int pos,int value);
  };

#endif
