/*******************************************************************************
*                                 Sudoku                                       *
********************************************************************************
*            Copyright (C) 2006 Sander Jansen. All Rights Reserved             *
*                               ---                                            *
* This program is free software; you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation; either version 2 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
* You should have received a copy of the GNU General Public License            *
* along with this program; if not, write to the Free Software                  *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    *
*******************************************************************************/
/*
$Id$
*/
#ifndef SUDOKUWINDOW_H
#define SUDOKUWINDOW_H

#include "sudoku.h"

class SudokuWindow : public FXMainWindow {
FXDECLARE(SudokuWindow)
private:
  Sudoku sudoku_puzzle;  // Initial Puzzle
  Sudoku sudoku_current; // Current
private:
  FXUndoList undolist;
  FXTextField * field[81];
  FXTextField * pv[81];
  FXMenuPane * filemenu;
  FXMenuPane * editmenu;
  FXMenuPane * helpmenu;
  FXFont * largefont;
  FXFont * smallfont;
private:
  FXIcon * icon_exit;
  FXIcon * icon_logo;
  FXIcon * icon_logo_small;
  FXIcon * icon_logo_about;
  FXIcon * icon_undo;
  FXIcon * icon_redo;
protected:
  SudokuWindow(){}
  void init();
  void removePossibleValues(int i);
  bool saveGame(const FXString &);
  bool loadGame(const FXString &);
public:
  enum {
    ID_FIELD_0=FXMainWindow::ID_LAST,
    ID_FIELD_80=ID_FIELD_0+80,
    ID_ANNOTATION_0,
    ID_ANNOTATION_80=ID_ANNOTATION_0+80,
    ID_SOLVE,
    ID_LOAD,
    ID_SAVE,
    ID_CLEAR,
    ID_RESET,
    ID_ABOUT,
    };
public:
  long onCmdAbout(FXObject*,FXSelector,void*);
  long onCmdLoad(FXObject*,FXSelector,void*);
  long onCmdSave(FXObject*,FXSelector,void*);
  long onUpdSave(FXObject*,FXSelector,void*);
  long onCmdClear(FXObject*,FXSelector,void*);
  long onCmdReset(FXObject*,FXSelector,void*);
  long onCmdSolve(FXObject*,FXSelector,void*);
  long onUpdSolve(FXObject*,FXSelector,void*);
  long onCmdAnnotation(FXObject*,FXSelector,void*);
  long onCmdField(FXObject*,FXSelector,void*);
  long onVerifyField(FXObject*,FXSelector,void*);
public:
  SudokuWindow(FXApp *);

  virtual void create();

  virtual ~SudokuWindow();
  };

#endif


