/*******************************************************************************
*                                 Sudoku                                       *
********************************************************************************
*            Copyright (C) 2006 Sander Jansen. All Rights Reserved             *
*                               ---                                            *
* This program is free software; you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation; either version 2 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
* You should have received a copy of the GNU General Public License            *
* along with this program; if not, write to the Free Software                  *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    *
*******************************************************************************/
/*
$Id$
*/
#include <fx.h>
#include "sudokumove.h"

SudokuMove::SudokuMove(FXTextField * field,FXchar undovalue) {
  text=field;
  value=undovalue;
  }

void SudokuMove::undo() {
  FXchar redovalue = FXIntVal(text->getText());
  if (value>0)
    text->setText(FXStringVal(value),true);
  else
    text->setText(FXString::null,true);

  text->setFocus();
  value=redovalue;
  }

void SudokuMove::redo() {
  FXchar undovalue = FXIntVal(text->getText());
  if (value>0)
    text->setText(FXStringVal(value),true);
  else
    text->setText(FXString::null,true);
  text->setFocus();
  value=undovalue;
  }

FXuint SudokuMove::size() const {
  return sizeof(SudokuMove);
  }

FXString SudokuMove::undoName() const {
  return "Undo Move";
  }

FXString SudokuMove::redoName() const{
  return "Redo Move";
  }

bool SudokuMove::canMerge() const {
  return true;
  }

bool SudokuMove::mergeWith(FXCommand* command) {
  SudokuMove * move = dynamic_cast<SudokuMove*>(command);
  if (move && move->text==text) {
    value=move->value;
    return true;
    }
  return false;
  }
